// Code generated by protoc-gen-go. DO NOT EDIT.
// source: attribute_service.proto

package position_service

import (
	context "context"
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

func init() { proto.RegisterFile("attribute_service.proto", fileDescriptor_f8573bba259fe8c2) }

var fileDescriptor_f8573bba259fe8c2 = []byte{
	// 208 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0x12, 0x4f, 0x2c, 0x29, 0x29,
	0xca, 0x4c, 0x2a, 0x2d, 0x49, 0x8d, 0x2f, 0x4e, 0x2d, 0x2a, 0xcb, 0x4c, 0x4e, 0xd5, 0x2b, 0x28,
	0xca, 0x2f, 0xc9, 0x17, 0xe2, 0x48, 0x4f, 0xcd, 0x03, 0xb3, 0xa4, 0xf8, 0xe1, 0x4a, 0x20, 0x52,
	0x46, 0xa7, 0x98, 0xb8, 0x04, 0x1c, 0x61, 0x62, 0xc1, 0x10, 0x5d, 0x42, 0x66, 0x5c, 0x6c, 0xce,
	0x45, 0xa9, 0x89, 0x25, 0xa9, 0x42, 0xc2, 0x7a, 0x30, 0xad, 0x7a, 0x70, 0x55, 0x52, 0xa2, 0x58,
	0x04, 0x3d, 0x53, 0x94, 0x18, 0x84, 0xfc, 0xb9, 0xd8, 0xdc, 0x53, 0x4b, 0x1c, 0x73, 0x72, 0x84,
	0x14, 0x10, 0x4a, 0x20, 0x22, 0x70, 0x85, 0x41, 0xa9, 0x85, 0xa5, 0xa9, 0xc5, 0x25, 0x52, 0x8a,
	0x78, 0x54, 0x14, 0x17, 0xe4, 0xe7, 0x15, 0xa7, 0x2a, 0x31, 0x08, 0x19, 0x73, 0x31, 0xbb, 0xa7,
	0x96, 0x08, 0x61, 0xb7, 0x50, 0x0a, 0x9b, 0xe3, 0x94, 0x18, 0x84, 0xac, 0xb8, 0xd8, 0x42, 0x0b,
	0x52, 0x70, 0xba, 0x5e, 0x12, 0x21, 0x18, 0x5c, 0x92, 0x58, 0x52, 0x5a, 0x8c, 0xac, 0xd7, 0x86,
	0x8b, 0xcd, 0x25, 0x35, 0x27, 0xb5, 0x24, 0x15, 0x97, 0x9d, 0xf8, 0x74, 0x3b, 0x49, 0x47, 0x49,
	0xc2, 0x64, 0xf5, 0x0b, 0xf2, 0x8b, 0x33, 0x4b, 0x32, 0xf3, 0xf3, 0x60, 0x51, 0x91, 0xc4, 0x06,
	0x16, 0x37, 0x06, 0x04, 0x00, 0x00, 0xff, 0xff, 0x11, 0x9c, 0x8e, 0xf6, 0xa6, 0x01, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// AttributeServiceClient is the client API for AttributeService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type AttributeServiceClient interface {
	Create(ctx context.Context, in *Attribute, opts ...grpc.CallOption) (*AttributeId, error)
	GetAll(ctx context.Context, in *GetAllAttributeRequest, opts ...grpc.CallOption) (*GetAllAttributeResponse, error)
	Get(ctx context.Context, in *AttributeId, opts ...grpc.CallOption) (*Attribute, error)
	Update(ctx context.Context, in *Attribute, opts ...grpc.CallOption) (*StatusAttribute, error)
	Delete(ctx context.Context, in *AttributeId, opts ...grpc.CallOption) (*StatusAttribute, error)
}

type attributeServiceClient struct {
	cc *grpc.ClientConn
}

func NewAttributeServiceClient(cc *grpc.ClientConn) AttributeServiceClient {
	return &attributeServiceClient{cc}
}

func (c *attributeServiceClient) Create(ctx context.Context, in *Attribute, opts ...grpc.CallOption) (*AttributeId, error) {
	out := new(AttributeId)
	err := c.cc.Invoke(ctx, "/genproto.AttributeService/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *attributeServiceClient) GetAll(ctx context.Context, in *GetAllAttributeRequest, opts ...grpc.CallOption) (*GetAllAttributeResponse, error) {
	out := new(GetAllAttributeResponse)
	err := c.cc.Invoke(ctx, "/genproto.AttributeService/GetAll", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *attributeServiceClient) Get(ctx context.Context, in *AttributeId, opts ...grpc.CallOption) (*Attribute, error) {
	out := new(Attribute)
	err := c.cc.Invoke(ctx, "/genproto.AttributeService/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *attributeServiceClient) Update(ctx context.Context, in *Attribute, opts ...grpc.CallOption) (*StatusAttribute, error) {
	out := new(StatusAttribute)
	err := c.cc.Invoke(ctx, "/genproto.AttributeService/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *attributeServiceClient) Delete(ctx context.Context, in *AttributeId, opts ...grpc.CallOption) (*StatusAttribute, error) {
	out := new(StatusAttribute)
	err := c.cc.Invoke(ctx, "/genproto.AttributeService/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AttributeServiceServer is the server API for AttributeService service.
type AttributeServiceServer interface {
	Create(context.Context, *Attribute) (*AttributeId, error)
	GetAll(context.Context, *GetAllAttributeRequest) (*GetAllAttributeResponse, error)
	Get(context.Context, *AttributeId) (*Attribute, error)
	Update(context.Context, *Attribute) (*StatusAttribute, error)
	Delete(context.Context, *AttributeId) (*StatusAttribute, error)
}

// UnimplementedAttributeServiceServer can be embedded to have forward compatible implementations.
type UnimplementedAttributeServiceServer struct {
}

func (*UnimplementedAttributeServiceServer) Create(ctx context.Context, req *Attribute) (*AttributeId, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (*UnimplementedAttributeServiceServer) GetAll(ctx context.Context, req *GetAllAttributeRequest) (*GetAllAttributeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetAll not implemented")
}
func (*UnimplementedAttributeServiceServer) Get(ctx context.Context, req *AttributeId) (*Attribute, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (*UnimplementedAttributeServiceServer) Update(ctx context.Context, req *Attribute) (*StatusAttribute, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (*UnimplementedAttributeServiceServer) Delete(ctx context.Context, req *AttributeId) (*StatusAttribute, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}

func RegisterAttributeServiceServer(s *grpc.Server, srv AttributeServiceServer) {
	s.RegisterService(&_AttributeService_serviceDesc, srv)
}

func _AttributeService_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Attribute)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AttributeServiceServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/genproto.AttributeService/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AttributeServiceServer).Create(ctx, req.(*Attribute))
	}
	return interceptor(ctx, in, info, handler)
}

func _AttributeService_GetAll_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetAllAttributeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AttributeServiceServer).GetAll(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/genproto.AttributeService/GetAll",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AttributeServiceServer).GetAll(ctx, req.(*GetAllAttributeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _AttributeService_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AttributeId)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AttributeServiceServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/genproto.AttributeService/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AttributeServiceServer).Get(ctx, req.(*AttributeId))
	}
	return interceptor(ctx, in, info, handler)
}

func _AttributeService_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Attribute)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AttributeServiceServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/genproto.AttributeService/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AttributeServiceServer).Update(ctx, req.(*Attribute))
	}
	return interceptor(ctx, in, info, handler)
}

func _AttributeService_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AttributeId)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AttributeServiceServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/genproto.AttributeService/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AttributeServiceServer).Delete(ctx, req.(*AttributeId))
	}
	return interceptor(ctx, in, info, handler)
}

var _AttributeService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "genproto.AttributeService",
	HandlerType: (*AttributeServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _AttributeService_Create_Handler,
		},
		{
			MethodName: "GetAll",
			Handler:    _AttributeService_GetAll_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _AttributeService_Get_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _AttributeService_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _AttributeService_Delete_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "attribute_service.proto",
}
